/*************************************************************************
*
*	Function:  To show how to use events in C++.
*
*	Author:  Karl Riehl
*
*	Date:  May 2, 2005
*
*	Project:  Senior Capstone 2005 - Comm Port API
*
*************************************************************************/

//Includes
#include <windows.h>
#include <iostream.h>
#include "CMU.h"


int main()
{
	unsigned char ver[19];
	unsigned char Frame[FRAME_SIZE];
	unsigned char* IMAGE;
	S_PACKET spack;
	M_PACKET mpack;
	C_PACKET cpack;
	N_PACKET npack;

///////////
//////////////////////
/////////////INIT CODE///////////
//////////////////////
///////////
	if(!CAM_Init("COM1"))
		cout << "ERROR: Port Failure(0)" << endl;
	else
		cout << "Port Opened" << endl;
	cout << "-----------------\n" << endl;

	if(!CAM_Ping())
	{
		cout << "Ping Error" << endl;
		Sleep(500);
		return 1;
	}


///////////
//////////////////////
/////////////ACTUAL CODE///////////
//////////////////////
///////////
/*
	if(!CAM_Ping())
		cout << "Ping Error" << endl;
	else
		cout << "Ping Success" << endl;

	cout << "\n*-----------------*\n" << endl;

	if(!CAM_TrackLight(MODE_ON))
		cout << "TrackLight On Error" << endl;
	else
		cout << "TrackLight On.....ok" << endl;

	cout << "\n*-----------------*\n" << endl;

	if(!CAM_TrackLight(MODE_OFF))
		cout << "TrackLight Off Error" << endl;
	else
		cout << "TrackLight Off.....ok" << endl;

	cout << "\n*-----------------*\n" << endl;

	if(!CAM_ClockSpeed(CR_FPS_17))
		cout << "ClockSpeed Error" << endl;
	else
		cout << "ClockSpeed.....ok" << endl;

	cout << "\n*-----------------*\n" << endl;

	if(!CAM_Brightness(158))
		cout << "Brightness Error" << endl;
	else
		cout << "Brightness.....ok" << endl;

	cout << "\n*-----------------*\n" << endl;

	if(!CAM_Contrast(23))
		cout << "Contrast Error" << endl;
	else
		cout << "Contrast.....ok" << endl;

	cout << "\n*-----------------*\n" << endl;

	if(!CAM_GetVersion(ver))
		cout << "Version Error" << endl;
	else
		cout << "Version....." << ver << endl;

	cout << "\n*-----------------*\n" << endl;

	if(!CAM_HalfHorizontalMode(MODE_ON))
		cout << "HalfHorizonal Error" << endl;
	else
		cout << "HalfHorizonal.....ok" << endl;

	cout << "\n*-----------------*\n" << endl;

	if(!CAM_NoiseFilter(MODE_ON))
		cout << "NoiseFilter Error" << endl;
	else
		cout << "NoiseFilter.....ok"  << endl;

	cout << "\n*-----------------*\n" << endl;
	
	if(!CAM_MiddleMassMode(MM_ON))
		cout << "MiddleMass Error" << endl;
	else
		cout << "MiddleMass.....ok"  << endl;

	cout << "\n*-----------------*\n" << endl;

	if(!CAM_SwitchMode(MODE_OFF))
		cout << "SwitchMode Error" << endl;
	else
		cout << "SwitchMode.....ok"  << endl;

	cout << "\n*-----------------*\n" << endl;








	if(!CAM_STR_MC())
		cout << "Init MeanColor Stream Error" << endl;
	else
		cout << "MeanColor Stream.....ok"  << endl;

	cout << "\n*-----------------*\n" << endl;

	if(!CAM_Get_MC(&spack))
		cout << "Couldn't Get MeanColor Data Error" << endl;
	else
		cout << "Got MeanColor Data as Follows:" << endl;

	cout << "Rmean: " << spack.Rmean << endl;
	cout << "Gmean: " << spack.Gmean << endl;
	cout << "Bmean: " << spack.Bmean << endl;
	cout << "Rdev: " << spack.Rdev << endl;
	cout << "Gdev: " << spack.Gdev << endl;
	cout << "Bdev: " << spack.Bdev << endl;

	cout << "\n*-----------------*\n" << endl;

	if(!CAM_EndPacket())
		cout << "EndPacket Error" << endl;
	else
		cout << "EndPacket.....ok"  << endl;

	cout << "\n*-----------------*\n" << endl;






	if(!CAM_STR_TCO_Centroid())
		cout << "Init TCO Stream ON Error" << endl;
	else
		cout << "Init TCO Stream ON.....ok"  << endl;

	cout << "\n*-----------------*\n" << endl;


	if(!CAM_Get_TCO_Centroid(&mpack))
		cout << "Couldn't Get TCO ON Data Error" << endl;
	else
		cout << "Got TCO ON Data as Follows:" << endl;

	cout << "Mx: " << mpack.MX  << endl;
	cout << "My: " << mpack.MY  << endl;
	cout << "X1: " << mpack.X1  << endl;
	cout << "Y1: " << mpack.Y1  << endl;
	cout << "X2: " << mpack.X2  << endl;
	cout << "Y2: " << mpack.Y2  << endl;
	cout << "Confidence: " << mpack.Confid   << endl;
	cout << "Pixel Count: " << mpack.Num_Pix  << endl;

	cout << "\n*-----------------*\n" << endl;

	if(!CAM_EndPacket())
		cout << "EndPacket Error" << endl;
	else
		cout << "EndPacket.....ok"  << endl;

	cout << "\n*-----------------*\n" << endl;









	if(!CAM_STR_TCO())
		cout << "Init TCO Stream OFF Error" << endl;
	else
		cout << "Init TCO Stream OFF.....ok"  << endl;

	cout << "\n*-----------------*\n" << endl;


	if(!CAM_Get_TCO(&cpack))
		cout << "Couldn't Get TCO ON Data Error" << endl;
	else
		cout << "Got TCO ON Data as Follows:" << endl;

	cout << "X1: " << cpack.X1  << endl;
	cout << "Y1: " << cpack.Y1  << endl;
	cout << "X2: " << cpack.X2  << endl;
	cout << "Y2: " << cpack.Y2  << endl;
	cout << "Confidence: " << cpack.Confid   << endl;
	cout << "Pixel Count: " << cpack.Num_Pix  << endl;

	cout << "\n*-----------------*\n" << endl;

	if(!CAM_EndPacket())
		cout << "EndPacket Error" << endl;
	else
		cout << "EndPacket.....ok"  << endl;

	cout << "\n*-----------------*\n" << endl;








	if(!CAM_STR_TCO_Servo())
		cout << "Init TCO Stream Servo Error" << endl;
	else
		cout << "Init TCO Stream Servo.....ok"  << endl;

	cout << "\n*-----------------*\n" << endl;

	if(!CAM_Get_TCO_Servo(&npack))
		cout << "Couldn't Get TCO ON Data Error" << endl;
	else
		cout << "Got TCO ON Data as Follows:" << endl;

	cout << "Spos: " << npack.Spos << endl;
	cout << "Mx: " << npack.MX  << endl;
	cout << "My: " << npack.MY  << endl;
	cout << "X1: " << npack.X1  << endl;
	cout << "Y1: " << npack.Y1  << endl;
	cout << "X2: " << npack.X2  << endl;
	cout << "Y2: " << npack.Y2  << endl;
	cout << "Confidence: " << npack.Confid   << endl;
	cout << "Pixel Count: " << npack.Num_Pix  << endl;

	if(!CAM_EndPacket())
		cout << "EndPacket Error" << endl;
	else
		cout << "EndPacket.....ok"  << endl;

	cout << "\n*-----------------*\n" << endl;


	if(!CAM_ColMode_RGB_OFF())
		cout << "RGB OFF Error" << endl;
	else
		cout << "RGB OFF.....ok"  << endl;

	cout << "\n*-----------------*\n" << endl;

	
	if(!CAM_ColMode_RGB_ON())
		cout << "RGB ON Error" << endl;
	else
		cout << "RGB ON.....ok"  << endl;

	cout << "\n*-----------------*\n" << endl;


	if(!CAM_ColMode_YCrCb_OFF())
		cout << "YCrCb OFF Error" << endl;
	else
		cout << "YCrCb OFF.....ok"  << endl;

	cout << "\n*-----------------*\n" << endl;


	if(!CAM_ColMode_YCrCb_ON())
		cout << "YCrCb ON Error" << endl;
	else
		cout << "YCrCb ON.....ok"  << endl;

	cout << "\n*-----------------*\n" << endl;


	if(!CAM_AutoExposure_GainON())
		cout << "AutoGain ON Error" << endl;
	else
		cout << "AutoGain ON.....ok"  << endl;

	cout << "\n*-----------------*\n" << endl;

	if(!CAM_AutoExposure_GainOFF())
		cout << "AutoGain OFF Error" << endl;
	else
		cout << "AutoGain OFF.....ok"  << endl;

	cout << "\n*-----------------*\n" << endl;


*/

	//Close the Port when done
	CAM_ClosePort();

	cout << "\n\nClosing Port.....\n\n" << endl;
	Sleep(2000);

	return 21;
}